<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\ImpactoManutService;
use FM\Traits\TResponse;

class ImpactoManutController {
    use TResponse;
    protected $ImpactoManutService;

    public function __construct(ImpactoManutService $ImpactoManutService) {
        $this->ImpactoManutService = $ImpactoManutService;
    }

    public function saveImpacto(Request $request) {
        try {
            $params = $request->getParameters();
            $this->ImpactoManutService->saveImpacto($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getImpactosManutencao(Request $request) {
        try {
            $data = $this->ImpactoManutService->getImpactosManutencao();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deleteImpactos(Request $request) {
        try {
            $params = $request->getParameters();
            $this->ImpactoManutService->deleteImpactos($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}

?>