<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\PrioridadeManutService;
use FM\Traits\TResponse;

class PrioridadeManutController
{
    use TResponse;
    protected $PrioridadeManutService;

    public function __construct(PrioridadeManutService $PrioridadeManutService)
    {
        $this->PrioridadeManutService = $PrioridadeManutService;
    }

    public function savePrioridade(Request $request)
    {
        try {
            $params = $request->getParameters();
            $this->PrioridadeManutService->savePrioridade($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getPrioridadesManutencao()
    {
        try {
            $data = $this->PrioridadeManutService->getPrioridadesManutencao();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getImpactosRelacionados()
    {
        try {
            $data = $this->PrioridadeManutService->getImpactosRelacionados();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deletePrioridades(Request $request)
    {
        try {
            $params = $request->getParameters();
            $this->PrioridadeManutService->deletePrioridades($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
