<?php

namespace FM\Service;

use FM\Factory\TipoManutencaoFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class TipoManutencaoService {

    protected $TipoManutencaoFactory;
    protected $Environment;
    protected $newCode;

    public function __construct (EntityManager $entityManager, TipoManutencaoFactory $TipoManutencaoFactory, Environment $Environment, NewCode $newCode) {
        $this->TipoManutencaoFactory = $TipoManutencaoFactory;
        $this->connection            = $entityManager->getConnection();
        $this->Environment           = $Environment;
        $this->newCode               = $newCode;
    }

    public function saveTipoManutencao($params) {
        $this->connection->beginTransaction();

        try {
            $nrorg = $this->Environment->getNrorg();
            $operador = $this->Environment->getCdOperador();
            
            foreach ($params["ROWS"] as $row) {
                if ($row["NRTIPOMANUTENCAO"] == 0) {
                    $NRTIPOMANUTENCAO = $this->newCode->getCodeByTableName("FCM_TIPOMANUTENCAO", $nrorg, 1, 10, true);
    
                    $parametrosTipo = array(
                        "NRTIPOMANUTENCAO"  => $NRTIPOMANUTENCAO,
                        "NMTIPOMANUTENCAO"  => $row['NMTIPOMANUTENCAO'],
                        "NRORG"             => $nrorg,
                        "CDOPERINCLUSAO"    => $operador,
                        "NRORGINCLUSAO"     => $nrorg,
                        "CDOPERULTATU"      => $operador,
                        "NRORGULTATU"       => $nrorg          
                    );

                    $this->TipoManutencaoFactory->insertTipoManutencao($parametrosTipo);
                } else {
                    $parametrosTipo = array(
                        "NRTIPOMANUTENCAO"  => $row['NRTIPOMANUTENCAO'],
                        "NMTIPOMANUTENCAO"  => $row['NMTIPOMANUTENCAO'],
                        "CDOPERULTATU"      => $operador,
                        "NRORGULTATU"       => $nrorg          
                    );

                    $this->TipoManutencaoFactory->editTipoManutencao($parametrosTipo);
                }
            }

            $this->connection->commit();
        } catch (\Exception $ex) {
            $this->connection->rollback();
            throw $ex;
        }
    }

    public function getTiposManutencao() {
        return $this->TipoManutencaoFactory->getTiposManutencao();
    }

    public function deleteTiposManutencao($params) {
        $parametro = implode(',', $params["NRS"]);
        $this->TipoManutencaoFactory->deleteTiposManutencao($parametro);
    }
}

?>