<?php

namespace FM\Service;

use FM\Factory\UnidadeMedidaFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class UnidadeMedidaService {

    protected $UnidadeMedidaFactory;
    protected $Environment;
    protected $newCode;

    public function __construct (EntityManager $entityManager, UnidadeMedidaFactory $UnidadeMedidaFactory, Environment $Environment, NewCode $newCode) {
        $this->UnidadeMedidaFactory = $UnidadeMedidaFactory;
        $this->connection           = $entityManager->getConnection();
        $this->Environment          = $Environment;
        $this->newCode              = $newCode;
    }

    public function saveUnidadeMedida($params) {
        $this->connection->beginTransaction();

        try {
            $nrorg = $this->Environment->getNrorg();
            $operador = $this->Environment->getCdOperador();
            
            foreach ($params["ROWS"] as $row) {
                if ($row["NRUNIDADEMEDIDA"] == 0) {
                    $NRUNIDADEMEDIDA = $this->newCode->getCodeByTableName("FCM_UNIDADEMEDIDA", $nrorg, 1, 10, true);
    
                    $parametrosUnidade = array(
                        "NRUNIDADEMEDIDA"       => $NRUNIDADEMEDIDA,
                        "NMUNIDADEMEDIDA"       => $row['NMUNIDADEMEDIDA'],
                        "NMABREVUNIDADEMEDIDA"  => $row['NMABREVUNIDADEMEDIDA'],
                        "NRORG"                 => $nrorg,
                        "CDOPERINCLUSAO"        => $operador,
                        "NRORGINCLUSAO"         => $nrorg,
                        "CDOPERULTATU"          => $operador,
                        "NRORGULTATU"           => $nrorg          
                    );

                    $this->UnidadeMedidaFactory->insertUnidadeMedida($parametrosUnidade);
                } else {
                    $parametrosUnidade = array(
                        "NRUNIDADEMEDIDA"       => $row['NRUNIDADEMEDIDA'],
                        "NMUNIDADEMEDIDA"       => $row['NMUNIDADEMEDIDA'],
                        "NMABREVUNIDADEMEDIDA"  => $row['NMABREVUNIDADEMEDIDA'],
                        "CDOPERULTATU"          => $operador,
                        "NRORGULTATU"           => $nrorg          
                    );

                    $this->UnidadeMedidaFactory->editUnidadeMedida($parametrosUnidade);
                }
            }

            $this->connection->commit();
        } catch (\Exception $ex) {
            $this->connection->rollback();
            throw $ex;
        }
    }

    public function getUnidadesMedida() {
        return $this->UnidadeMedidaFactory->getUnidadesMedida();
    }

    public function deleteUnidadesMedida($params) {
        $parametro = implode(',', $params["NRS"]);
        $this->UnidadeMedidaFactory->deleteUnidadesMedida($parametro);
    }
}

?>