/* eslint-disable */
import {
  Metadata, Http, IDictionary,
} from '@zeedhi/core';
import {
  AlertService, Button, Col, DialogService, Form, Icon, Modal, ModalService,
  Select, SelectMultiple, TextInput,
} from '@zeedhi/common';
import { IterableComponentRender } from '@zeedhi/teknisa-components-common';
import ZdColorPicker from '@/components/colorPicker/ZdColorPicker';

export class ControllerParametrizacao {
  private ModalAdicionarCategoria!: Modal;

  private ModalTipoManutencao!: Modal;

  private ModalAdicionarPrioridades! : Modal;

  private ModalAdicionarImpacto! : Modal;

  private ModalAdicionarEscopo!: Modal;

  private ModalAdicionarUnidadeMedida!: Modal;

  private ModalEditarCategoria!: Modal;

  private ModalEditarTipoManut!: Modal;

  private ModalEditarImpacto!: Modal;

  private ModalEditarPrioridade!: Modal;

  private ModalEditarEscopo!: Modal;

  private ModalEditarUnidadeMedida!: Modal;

  private NR: any;

  private dadosOriginal: any = {
    'iterable-cards-categorias': [],
    'dadosTipoManut': [],
    'iterable-cards-prioridades': [],
    'iterable-cards-impacto': [],
    'iterable-cards-escopo': [],
    'iterable-cards-unidadeMedida': [],
  };

  // ----------------- FUNÇÕES DOS MODAIS DE ADIÇÃO DE: CATEGORIAS, TIPO, PRIORIDADES E IMPACTO ------------------
  public async abrirModal({ component }:{ component: Button }) {
    if (component.label === 'Adicionar Categoria de Manutenção') {
      this.ModalAdicionarCategoria = await ModalService.createFromJson('/modais/Modal_adicionarCategoriaManutencao', true);
      this.ModalAdicionarCategoria.show();
    } else if (component.label === 'Adicionar Tipo de Manutenção') {
      this.ModalTipoManutencao = await ModalService.createFromJson('/modais/Modal_adicionarTipoManutencao', true);
      this.ModalTipoManutencao.show();
    } else if (component.label === 'Adicionar Prioridades') {
      this.ModalAdicionarPrioridades = await ModalService.createFromJson('/modais/Modal_adicionarPrioridades', true);
      this.ModalAdicionarPrioridades.show();
    } else if (component.label === 'Adicionar Impacto') {
      this.ModalAdicionarImpacto = await ModalService.createFromJson('/modais/Modal_adicionarImpacto', true);
      this.ModalAdicionarImpacto.show();
    } else if (component.label === 'Adicionar Escopo') {
      this.ModalAdicionarEscopo = await ModalService.createFromJson('/modais/Modal_adicionarEscopo', true);
      this.ModalAdicionarEscopo.show();
    } else if (component.label === 'Adicionar Unidade de Medida') {
      this.ModalAdicionarUnidadeMedida = await ModalService.createFromJson('/modais/Modal_adicionarUnidadeMedida', true);
      this.ModalAdicionarUnidadeMedida.show();
    }
  }

  // Função para abrir o modal que edita uma categoria, e pega o NR daquele card
  public async abrirModalEdicaoCategoria({ component }:{ component: Button }) {
    this.NR = Number(component.name.split('_')[1]);
    this.ModalEditarCategoria = await ModalService.createFromJson('/modais/Modal_editarCategoriaManutencao', true);
    this.ModalEditarCategoria.show();
  }

  // Função para abrir o modal que edita um tipo de manutencao, e pega o NR daquele card
  public async abrirModalEdicaoTipoManut({ component }:{ component: Button }) {
    this.NR = Number(component.name.split('_')[1]);
    this.ModalEditarTipoManut = await ModalService.createFromJson('/modais/Modal_editarTipoManutencao', true);
    this.ModalEditarTipoManut.show();
  }

  public async abrirModalEdicaoImpacto({ component }:{ component: Button }) {
    this.NR = Number(component.name.split('_')[1]);
    this.ModalEditarImpacto = await ModalService.createFromJson('/modais/Modal_editarImpacto', true);
    this.ModalEditarImpacto.show();
  }

  public async abrirModalEdicaoPrioridade({ component }:{ component: Button }) {
    this.NR = Number(component.name.split('_')[1]);
    this.ModalEditarPrioridade = await ModalService.createFromJson('/modais/Modal_editarPrioridades', true);
    this.ModalEditarPrioridade.show();
  }

  public async abrirModalEditarEscopo({ component }:{ component: Button }) {
    this.NR = Number(component.name.split('_')[1]);
    this.ModalEditarEscopo = await ModalService.createFromJson('/modais/Modal_editarEscopo', true);
    this.ModalEditarEscopo.show();
  }

  public async abrirModalEditarUnidadeMedida({ component }:{ component: Button }) {
    this.NR = Number(component.name.split('_')[1]);
    this.ModalEditarUnidadeMedida = await ModalService.createFromJson('/modais/Modal_editarUnidadeMedida', true);
    this.ModalEditarUnidadeMedida.show();
  }

  public fecharModalAdicionarCategoria() {
    this.ModalAdicionarCategoria.hide();
    this.ModalAdicionarCategoria?.destroy();
  }

  public fecharModalTipoManutencao() {
    this.ModalTipoManutencao.hide();
    this.ModalTipoManutencao?.destroy();
  }

  public fecharModalAdicionarPrioridade() {
    this.ModalAdicionarPrioridades.hide();
    this.ModalAdicionarPrioridades?.destroy();
  }

  public fecharModalAdicionarImpacto() {
    this.ModalAdicionarImpacto.hide();
    this.ModalAdicionarImpacto?.destroy();
  }

  public fecharModalAdicionarUnidadeMedida() {
    this.ModalAdicionarUnidadeMedida.hide();
    this.ModalAdicionarUnidadeMedida?.destroy();
  }

  public fecharModalAdicionarEscopo() {
    this.ModalAdicionarEscopo.hide();
    this.ModalAdicionarEscopo?.destroy();
  }

  public fecharModalEditarCategoria() {
    this.ModalEditarCategoria.hide();
    this.ModalEditarCategoria?.destroy();
  }

  public fecharModalEditarTipoManut() {
    this.ModalEditarTipoManut.hide();
    this.ModalEditarTipoManut?.destroy();
  }

  public fecharModalEditarImpacto() {
    this.ModalEditarImpacto.hide();
    this.ModalEditarImpacto?.destroy();
  }

  public fecharModalEditarPrioridades() {
    this.ModalEditarPrioridade.hide();
    this.ModalEditarPrioridade?.destroy();
  }

  public fecharModalEditarEscopo() {
    this.ModalEditarEscopo.hide();
    this.ModalEditarEscopo?.destroy();
  }

  public fecharModalEditarUnidadeMedida() {
    this.ModalEditarUnidadeMedida.hide();
    this.ModalEditarUnidadeMedida?.destroy();
  }

  // Funções que controlam a paginação dos cards e desabilita o botão de prox ou anterior
  public proximaPagina({ component }: any) {
    component.parent.datasource.page += 1;
    if (component.parent.paginationLength === component.parent.datasource.page) {
      component.disabled = true;
    }
    component.parent.datasource.get();
    Metadata.getInstance<Button>(`pagina-anterior-botao_${component.name.split('_')[1]}`).disabled = false;
  }

  public paginaAnterior({ component }: any) {
    if (component.parent.datasource.page > 1) {
      component.parent.datasource.page -= 1;
      if (component.parent.datasource.page === 1) {
        component.disabled = true;
      }
      component.parent.datasource.get();
      Metadata.getInstance<Button>(`proxima-pagina-botao_${component.name.split('_')[1]}`).disabled = false;
    }
  }

  // Função que desabilita os botões quando tem apenas uma página nos cards
  public maisQueUmaPagina({ component }: any) {
    component.disabled = !(Metadata.getInstance<IterableComponentRender>(component.name.split('_')[1]).paginationLength > 1);
  }

  public filtrarDados(dados: IDictionary, valoresASerFiltrado: any, colunaAFiltrar: any) {
    const dadosFiltrados: any = [];
    dados.forEach((dadoUnitario: any) => {
      if (dadoUnitario[colunaAFiltrar] !== null) {
        dadoUnitario[colunaAFiltrar].split(',').forEach((dadosColuna: any) => {
          if (valoresASerFiltrado.includes(dadosColuna)) {
            dadosFiltrados.push(dadoUnitario);
            return false;
          }
        });
      }
    });
    return dadosFiltrados;
  }

  public async filtrar({ component }: any) {
    const nomes = component.name.split('_');
    const iterable = Metadata.getInstance<IterableComponentRender>(nomes[1]);
    iterable.datasource.updateData(this.dadosOriginal[nomes[1]]);
    iterable.datasource.searchIn.forEach((colunas: string) => {
      const select = Metadata.getInstance<SelectMultiple>(`CampoFiltro_${nomes[1]}_${colunas}`).value;
      if (select.length) {
        const dadosIterable = (iterable.datasource as any);
        iterable.datasource.updateData(this.filtrarDados(dadosIterable.allData, select, colunas));
      }
    });
    this.maisQueUmaPagina({
      component: Metadata.getInstance<Button>(`proxima-pagina-botao_${nomes[1]}`),
    });
  }

  /* -----------> FUNÇÕES TAB: CATEGORIAS DE MANUTENÇÃO < ------------ */

  // Função que trás informações para o select de "Técnicos" - Modal adicionar Categoria de Manutenção
  public getFuncionarios({ component }:{ component: SelectMultiple }) {
    Http.get('/Funcionarios').then((response: IDictionary) => {
      component.datasource.data = response.data.dataset.employee;
    });
  }

  // Função que para adiciona uma nova categoria
  public adicionarNovaCategoriaManutecao() {
    const form = Metadata.getInstance<Form>('form-addCat');

    if (form.validate()) {
      Http.post('/CategoriaManut', {
        NMCATEGORIA: Metadata.getInstance<TextInput>('input-name-addCat').value,
        NMABREVIATURA: Metadata.getInstance<TextInput>('input-abv-addCat').value.toUpperCase(),
        TECNICOSREGISTRADOS: Metadata.getInstance<SelectMultiple>('sel-tecnico-addCat').value,
      }).then((response: IDictionary) => {
        const mensagemRetorno = response.data.dataset.categorias;
        const mensagem = 'Categoria adicionada com sucesso!';
        const textoErro = 'Esta categoria não pôde ser adicionada.';
        this.messages(mensagemRetorno, mensagem, textoErro);
      }).then(() => {
        this.criarCardsCategorias();
        this.fecharModalAdicionarCategoria();
      });
    } else {
      this.alertaPreencherCampos();
    }
  }

  // Função que trás as informações exibidas na modal de ediçao de categoria
  public montarInformacoesEdicao() {
    Http.post('/Categorias', { NR: this.NR }).then((response: IDictionary) => {
      const dados = response.data.dataset.categorias;

      Metadata.getInstance<TextInput>('input-name-editarCat').value = dados[0].NMCATEGORIAMANUT;
      Metadata.getInstance<TextInput>('input-abv-editarCat').value = dados[0].NMABREVCATEGMANUT;

      const funcionarios: any = [];
      dados.forEach((funcionario: any) => {
        funcionarios.push(funcionario.NRFUNCIONARIO);
      });
      Metadata.getInstance<SelectMultiple>('sel-tecnico-editarCat').setValue(funcionarios);
    });
  }

  // Função que cria os cards expostos na tela de categorias de manutenção
  public async criarCardsCategorias() {
    Http.get('/CategoriaManut').then((response: IDictionary) => {
      const dadosCategoria = response.data.dataset.categorias[0];
      const abreviatura = dadosCategoria.map((dados: any) => dados.NMABREVCATEGMANUT);
      const nomeCategoria = dadosCategoria.map((dados: any) => dados.NMCATEGORIAMANUT);
      const nomeFuncionario = (dadosCategoria.map((dados: any) => (dados.NRFUNCIONARIO !== null) ? dados.NRFUNCIONARIO.split(',') : ' ' )).flat(1);

      Metadata.getInstance<SelectMultiple>('CampoFiltro_iterable-cards-categorias_NMABREVCATEGMANUT').updateItems(abreviatura.filter((nome: string, pos: number) => abreviatura.indexOf(nome) === pos));
      Metadata.getInstance<SelectMultiple>('CampoFiltro_iterable-cards-categorias_NMCATEGORIAMANUT').updateItems(nomeCategoria.filter((nome: string, pos: number) => nomeCategoria.indexOf(nome) === pos));
      Metadata.getInstance<SelectMultiple>('CampoFiltro_iterable-cards-categorias_NRFUNCIONARIO').updateItems(nomeFuncionario.filter((nome: string, pos: number) => nomeFuncionario.indexOf(nome) === pos));

      this.dadosOriginal['iterable-cards-categorias'] = dadosCategoria;
      Metadata.getInstance<IterableComponentRender>('iterable-cards-categorias').datasource.updateData(dadosCategoria);
      this.maisQueUmaPagina({
        component: Metadata.getInstance<Button>('proxima-pagina-botao_iterable-cards-categorias'),
      });
    });
  }

  public editarCategoria() {
    const form = Metadata.getInstance<Form>('form-editarCategoria');

    if (form.validate()) {
      Http.post('/EditarCategoria', {
        NRCATEGORIAMANUT: this.NR,
        NMCATEGORIAMANUT: Metadata.getInstance<TextInput>('input-name-editarCat').value,
        NMABREVCATEGMANUT: Metadata.getInstance<TextInput>('input-abv-editarCat').value.toUpperCase(),
        NRFUNCIONARIO: Metadata.getInstance<SelectMultiple>('sel-tecnico-editarCat').value,
      }).then((response: IDictionary) => {
        const mensagemRetorno = response.data.dataset.categorias;
        const mensagem = 'Categoria editada com sucesso!';
        const textoErro = 'Está categoria não pôde ser editada.';
        this.messages(mensagemRetorno, mensagem, textoErro);
      }).then(() => {
        this.criarCardsCategorias();
        this.fecharModalEditarCategoria();
      });
    } else {
      this.alertaPreencherCampos();
    }
  }

  public alertaExclusao({ component }:{ component: Button }) {
    this.NR = Number(component.name.split('_')[1]);
    DialogService.show({
      name: 'buttons-dialog',
      type: 'warning',
      title: 'Excluir categoria',
      text: 'Todas as informações desta categoria serão perdidas. Tem certeza que deseja excluir esta categoria?',
      buttons: [
        {
          name: 'botao-nao',
          component: 'ZdButton',
          label: 'Não',
          outline: true,
          events: {
            click: () => DialogService.hide(),
          },
        },
        {
          name: 'botao-sim',
          component: 'ZdButton',
          label: 'Sim',
          events: {
            click: () => this.excluirCategoria(),
          },
        },
      ],
    });
  }

  public excluirCategoria() {
    Http.post('/ExcluirCategoria', { NRCATEGORIAMANUT: this.NR }).then((response: IDictionary) => {
      const mensagemRetorno = response.data.dataset.excluirCat;
      console.log(mensagemRetorno);
      const mensagem = 'Categoria excluída com sucesso!';
      const textoErro = 'Esta categoria não foi excluída.';
      this.messages(mensagemRetorno, mensagem, textoErro);
    }).then(() => {
      this.criarCardsCategorias();
      DialogService.hide();
    });
  }

  // ----------------- FUNÇÕES
  public messages(returnMessage: string, mensagem: string, textoErro: string) {
    if (returnMessage[0] === 'OK') {
      AlertService.show({
        name: 'basic-alert',
        text: `${mensagem}`,
        top: true,
        left: false,
        timeout: 3000,
        color: 'success',
      });
    } else {
      DialogService.show({
        name: 'warning-dialog',
        type: 'warning',
        title: 'Erro!',
        text: `Operação bloqueada! ${textoErro} <br><br>Se o problema persistir entre em contato com o suporte.`,
      });
    }
  }

  public alertaPreencherCampos() {
    AlertService.show({
      name: 'basic-alert',
      text: 'Preencha todos os campos obrigatórios (*)!',
      top: true,
      left: false,
      timeout: 3000,
      color: 'error',
    });
  }
  /* ----------> FUNÇÕES TAB TIPO MANUTENÇÃO ----------------- */

  public adicionarNovoTipoManutencao() {
    const form = Metadata.getInstance<Form>('form-addTpManut');
    const tipoManutencao = Metadata.getInstance<TextInput>('input-nome-addTpManut').value;

    if (form.validate()) {
      Http.post('/TipoManutencao', {
        NMTIPOMANUTENCAO: tipoManutencao.toUpperCase(),
      }).then((response: IDictionary) => {
        const mensagemRetorno = response.data.dataset.tipoManut;
        const mensagem = 'Tipo de Manutenção adicionado com sucesso!';
        const textoErro = 'Este tipo de Manutenção não foi adicionado.';
        this.messages(mensagemRetorno, mensagem, textoErro);
      }).then(() => {
        this.criarCardsTipoManutencao();
        this.fecharModalTipoManutencao();
      });
    } else {
      this.alertaPreencherCampos();
    }
  }

  public criarCardsTipoManutencao() {
    Http.get('/TipoManutencao').then((response: IDictionary) => {
      const dadosTipoManut = response.data.dataset.tipoManut[0];
      const nomeTipo = dadosTipoManut.map((dados: any) => dados.NMTIPOMANUTENCAO);

      Metadata.getInstance<SelectMultiple>('CampoFiltro_iterable-cards-tp_NMTIPOMANUTENCAO').updateItems(nomeTipo.filter((nome: string, pos: number) => nomeTipo.indexOf(nome) === pos));

      this.dadosOriginal['iterable-cards-tp'] = dadosTipoManut;
      Metadata.getInstance<IterableComponentRender>('iterable-cards-tp').datasource.updateData(dadosTipoManut);
      this.maisQueUmaPagina({
        component: Metadata.getInstance<Button>('proxima-pagina-botao_iterable-cards-tp'),
      });
    });
  }

  public montarInformacoesEdicaoTipoManut() {
    console.log(this.NR);
    Http.post('/TipoManut', { NRTIPOMANUTENCAO: this.NR }).then((response: IDictionary) => {
      const dados = response.data.dataset.tipoManutencao;

      Metadata.getInstance<TextInput>('input-nome-editarTipoManut').value = dados[0].NMTIPOMANUTENCAO;
    });
  }

  public editarTipoManutencao() {
    const form = Metadata.getInstance<Form>('form-editarTipoManut');

    if (form.validate()) {
      Http.post('/EditarTipoManutencao', {
        NRTIPOMANUTENCAO: this.NR,
        NMTIPOMANUTENCAO: Metadata.getInstance<TextInput>('input-nome-editarTipoManut').value.toUpperCase(),
      }).then((response: IDictionary) => {
        const mensagemRetorno = response.data.dataset.tipoManutencao;
        const mensagem = 'Tipo de Manutenção editada com sucesso!';
        const textoErro = 'Este tipo de manutenção não pôde ser editado.';
        this.messages(mensagemRetorno, mensagem, textoErro);
      }).then(() => {
        this.criarCardsTipoManutencao();
        this.fecharModalEditarTipoManut();
      });
    } else {
      this.alertaPreencherCampos();
    }
  }

  public alertaExclusaoTipoManutencao({ component }:{ component: Button }) {
    this.NR = Number(component.name.split('_')[1]);
    DialogService.show({
      name: 'buttons-dialog',
      type: 'warning',
      title: 'Excluir tipo de manutenção',
      text: 'Todas as informações deste tipo de manutenção serão perdidas. Deseja excluir mesmo assim?',
      buttons: [
        {
          name: 'botao-nao',
          component: 'ZdButton',
          label: 'Não',
          outline: true,
          events: {
            click: () => DialogService.hide(),
          },
        },
        {
          name: 'botao-sim',
          component: 'ZdButton',
          label: 'Sim',
          events: {
            click: () => this.excluirTipoManutencao(),
          },
        },
      ],
    });
  }

  public excluirTipoManutencao() {
    Http.post('/ExcluirTipoManutencao', { NRTIPOMANUTENCAO: this.NR }).then((response: IDictionary) => {
      const mensagemRetorno = response.data.dataset.excluirManut;
      const mensagem = 'Tipo de manutenção excluído com sucesso!';
      const textoErro = 'Este tipo de manutenção não pôde ser excluída.';
      this.messages(mensagemRetorno, mensagem, textoErro);
    }).then(() => {
      this.criarCardsTipoManutencao();
      DialogService.hide();
    });
  }
  /* ---------------------- FUNÇÕES TAB PRIORIDADES --------------------- */

  // Função que mostra a paleta do ZdColorPIcker apos clicar no botão "Definir cor"
  public definirCor({ component }: { component: Button }) {
    const nomeForm = component.name.split('_')[1];

    const form = Metadata.getInstance<Form>(nomeForm);

    form.children[0].grid!.cols = '8';
    form.children[1].grid!.cols = '4';
    const col = form.getChildInstance<Col>('BlocoDeCor');
    let corAnterior = Metadata.getInstance<Icon>('SquareWithColor').color;
    corAnterior = corAnterior !== 'transparent' ? corAnterior : '#F44336FF';
    col.children = [
      {
        name: 'SelecionarCor',
        component: 'ZdColorPicker',
        style: {
          position: 'relative',
          top: '-2em',
        },
        value: corAnterior,
      },
      {
        name: `botaoConfirmaColor_${nomeForm}`,
        component: 'ZdButton',
        label: 'Confirmar',
        style: {
          width: '100%',
          position: 'relative',
          top: '-1em',
        },
        events: {
          click: '{{ControllerParametrizacao.confirmarCor}}',
        },
      },
    ];
  }

  // Função que confirma a cor e mostra a visualização da mesma no quadrado, e te permite alterar a cor escolhida
  public confirmarCor({ component }: { component: Button }) {
    const nomeForm = component.name.split('_')[1];

    let color: any = Metadata.getInstance<ZdColorPicker>('SelecionarCor');
    color = color.value;
    const form = Metadata.getInstance<Form>(nomeForm);
    form.children[0].grid!.cols = '10';
    form.children[1].grid!.cols = '2';
    const col = form.getChildInstance<Col>('BlocoDeCor');
    col.children = [
      {
        name: 'TituloColor',
        component: 'ZdText',
        text: 'Alterar cor:',
        grid: {
          cols: '12',
        },
      },
      {
        name: `Color_${nomeForm}`,
        component: 'ZdButton',
        iconName: 'mdi-palette',
        small: true,
        grid: {
          cols: '6',
        },
        events: {
          click: '{{ControllerParametrizacao.definirCor}}',
        },
      },
      {
        name: 'SquareWithColor',
        component: 'ZdIcon',
        iconName: 'mdi-square',
        cssClass: 'zd-ml-3 quadrado-com-cor',
        color: `${color}`,
        grid: {
          cols: '6',
        },
      },
    ];
  }

  // Função que adiciona uma nova prioridade
  public adicionarPrioridade() {
    const form = Metadata.getInstance<Form>('form-addPrioridade');
    let corSelecionada: any = Metadata.getInstance<Icon>('SquareWithColor');
    corSelecionada = corSelecionada.color;

    if (form.validate()) {
      Http.post('/PrioridadeManut', {
        NMPRIORIDADE: Metadata.getInstance<TextInput>('input-nome-addPrioridade').value,
        CORPRIORIDADE: corSelecionada,
        NRIMPACTOS: Metadata.getInstance<SelectMultiple>('select-impactos-addPrioridade').value,
      }).then((response: IDictionary) => {
        const mensagemRetorno = response.data.dataset.prioridade;
        const mensagem = 'Prioridade adicionada com sucesso!';
        const textoErro = 'Esta prioridade não pôde ser adicionada.';
        this.messages(mensagemRetorno, mensagem, textoErro);
      }).then(() => {
        this.criarCardsPrioridades();
        this.criarCardsImpacto();
        this.fecharModalAdicionarPrioridade();
      });
    } else {
      this.alertaPreencherCampos();
    }
  }

  public criarCardsPrioridades() {
    Http.get('/PrioridadeManut').then((response: IDictionary) => {
      const dadosPrioridade = response.data.dataset.prioridade[0]
      const prioridades = dadosPrioridade.map((dados: any) => dados.NMPRIORIDADEMANUT);
      const impactos = (dadosPrioridade.map((dados: any) => (dados.NMIMPACTOPADRAOPRIORIDADE !== null) ? dados.NMIMPACTOPADRAOPRIORIDADE.split(',') : null )).flat(1);

      Metadata.getInstance<SelectMultiple>('CampoFiltro_iterable-cards-prioridades_NMPRIORIDADEMANUT').updateItems(prioridades.filter((nome: string, pos: number) => prioridades.indexOf(nome) === pos));
      Metadata.getInstance<SelectMultiple>('CampoFiltro_iterable-cards-prioridades_NMIMPACTOPADRAOPRIORIDADE').updateItems(impactos.filter((nome: string, pos: number) => impactos.indexOf(nome) === pos));

      this.dadosOriginal['iterable-cards-prioridades'] = dadosPrioridade;
      Metadata.getInstance<IterableComponentRender>('iterable-cards-prioridades').datasource.updateData(dadosPrioridade);
      this.maisQueUmaPagina({
        component: Metadata.getInstance<Button>('proxima-pagina-botao_iterable-cards-prioridades'),
      });
    });
  }

  public montarInformacoesEdicaoPrioridades() {
    Http.post('/Prioridades', { NRPRIORIDADEMANUT: this.NR }).then((response: IDictionary) => {
      const dados = response.data.dataset.prioridades;

      Metadata.getInstance<TextInput>('input-nome-editarPrioridade').value = dados[0].NMPRIORIDADEMANUT;
      Metadata.getInstance<Icon>('SquareWithColor').color = dados[0].DSCORPRIORIDADE;

      const impactos: any = [];
      dados.forEach((impacto: any) => {
        impactos.push(impacto.NRIMPACTOMANUT);
      });
      Metadata.getInstance<SelectMultiple>('select-impactos-editarPrioridade').setValue(impactos);
    });
  }

  public editarPrioridade() {
    const form = Metadata.getInstance<Form>('form-editarPrioridade');
    let corSelecionada: any = Metadata.getInstance<Icon>('SquareWithColor');
    corSelecionada = corSelecionada.color;

    if (form.validate()) {
      Http.post('/EditarPrioridade', {
        NRPRIORIDADEMANUT: this.NR,
        NMPRIORIDADEMANUT: Metadata.getInstance<TextInput>('input-nome-editarPrioridade').value,
        DSCORPRIORIDADE: corSelecionada,
        NRIMPACTOMANUT: Metadata.getInstance<SelectMultiple>('select-impactos-editarPrioridade').value,
      }).then((response: IDictionary) => {
        const mensagemRetorno = response.data.dataset.prioridade;
        const mensagem = 'Prioridade editada com sucesso!';
        const textoErro = 'Está prioridade não pôde ser editada.';
        this.messages(mensagemRetorno, mensagem, textoErro);
      }).then(() => {
        this.criarCardsPrioridades();
        this.fecharModalEditarPrioridades();
      });
    } else {
      this.alertaPreencherCampos();
    }
  }

  public alertaExclusaoPrioridade({ component }:{ component: Button }) {
    this.NR = Number(component.name.split('_')[1]);
    DialogService.show({
      name: 'buttons-dialog',
      type: 'warning',
      title: 'Excluir prioridade',
      text: 'Todas as informações desta prioridade serão perdidas. Deseja excluir mesmo assim?',
      buttons: [
        {
          name: 'botao-nao',
          component: 'ZdButton',
          label: 'Não',
          outline: true,
          events: {
            click: () => DialogService.hide(),
          },
        },
        {
          name: 'botao-sim',
          component: 'ZdButton',
          label: 'Sim',
          events: {
            click: () => this.excluirPrioridade(),
          },
        },
      ],
    });
  }

  public excluirPrioridade() {
    Http.post('/ExcluirPrioridade', { NRPRIORIDADEMANUT: this.NR }).then((response: IDictionary) => {
      const mensagemRetorno = response.data.dataset.excluirPrioridade;
      const mensagem = 'Prioridade excluída com sucesso!';
      const textoErro = 'Esta prioridade não pôde ser excluída, pois está em uso.';
      this.messages(mensagemRetorno, mensagem, textoErro);
    }).then(() => {
      this.criarCardsPrioridades();
      DialogService.hide();
      this.criarCardsImpacto();
    });
  }

  // Função que retorna os impactos no modal de adiconar prioridades, e no select da tab Prioridades
  public getImpactos({ component }:{ component: Select }) {
    Http.get('/ImpactoManut').then((response: IDictionary) => {
      response.data.dataset.impacto[0].forEach((dados :IDictionary) => {
        component.datasource.data.push({
          value: dados.NRIMPACTOMANUT,
          name: dados.NMIMPACTOMANUT,
        });
      });
    });
  }

  /* ---------------------- FUNÇÕES TAB IMPACTO --------------------- */

  // Função para adicionar um novo impacto
  public adicionarImpacto() {
    const form = Metadata.getInstance<Form>('form-addImpacto');

    if (form.validate()) {
      Http.post('/ImpactoManut', {
        NMIMPACTO: Metadata.getInstance<TextInput>('input-impacto-addImpacto').value,
        NRPRIORIDADE: Metadata.getInstance<Select>('select-prioridade-addImpacto').value,
      }).then((response: IDictionary) => {
        const mensagemRetorno = response.data.dataset.impacto;
        const mensagem = 'Impacto adicionado com sucesso!';
        const textoErro = 'Este impacto não pode ser adicionado.';
        this.messages(mensagemRetorno, mensagem, textoErro);
      }).then(() => {
        this.criarCardsImpacto();
        this.criarCardsPrioridades();
        this.fecharModalAdicionarImpacto();
      });
    } else {
      this.alertaPreencherCampos();
    }
  }

  public criarCardsImpacto() {
    Http.get('/ImpactoManut').then((response: IDictionary) => {
      const dadosImpactos = response.data.dataset.impacto[0];
      const nomeImpactos = dadosImpactos.map((dados: any) => dados.NMIMPACTOMANUT);
      const prioridadePadrao = dadosImpactos.map((dados: any) => dados.NMPRIORIDADEMANUT);

      Metadata.getInstance<SelectMultiple>('CampoFiltro_iterable-cards-impacto_NMIMPACTOMANUT').updateItems(nomeImpactos.filter((nome: string, pos: number) => nomeImpactos.indexOf(nome) === pos));
      Metadata.getInstance<SelectMultiple>('CampoFiltro_iterable-cards-impacto_NMPRIORIDADEMANUT').updateItems(prioridadePadrao.filter((nome: string, pos: number) => prioridadePadrao.indexOf(nome) === pos));

      this.dadosOriginal['iterable-cards-impacto'] = dadosImpactos;
      Metadata.getInstance<IterableComponentRender>('iterable-cards-impacto').datasource.updateData(dadosImpactos);
      this.maisQueUmaPagina({
        component: Metadata.getInstance<Button>('proxima-pagina-botao_iterable-cards-impacto'),
      });
    });
  }

  public montarInformacoesEdicaoImpacto() {
    Http.post('/Impactos', { NRIMPACTOMANUT: this.NR }).then((response: IDictionary) => {
      const dados = response.data.dataset.impactos;

      Metadata.getInstance<TextInput>('input-impacto-editarImpacto').value = dados[0].NMIMPACTOMANUT;
      const prioridade = dados[0].NRPRIORIDADEMANUTPADR;
      Metadata.getInstance<Select>('select-prioridade-editarImpacto').setValue(prioridade);
    });
  }

  public editarImpacto() {
    const form = Metadata.getInstance<Form>('form-editarImpacto');

    if (form.validate()) {
      Http.post('/EditarImpacto', {
        NRIMPACTOMANUT: this.NR,
        NMIMPACTOMANUT: Metadata.getInstance<TextInput>('input-impacto-editarImpacto').value,
        NRPRIORIDADEMANUTPADR: Metadata.getInstance<Select>('select-prioridade-editarImpacto').value,
      }).then((response: IDictionary) => {
        const mensagemRetorno = response.data.dataset.impacto;
        const mensagem = 'Impacto editado com sucesso!';
        const textoErro = 'Este impacto não pôde ser editado.';
        this.messages(mensagemRetorno, mensagem, textoErro);
      }).then(() => {
        this.criarCardsImpacto();
        this.criarCardsPrioridades();
        this.fecharModalEditarImpacto();
      });
    } else {
      this.alertaPreencherCampos();
    }
  }

  public alertaExclusaoImpacto({ component }:{ component: Button }) {
    this.NR = Number(component.name.split('_')[1]);
    DialogService.show({
      name: 'buttons-dialog',
      type: 'warning',
      title: 'Excluir impacto',
      text: 'Todas as informações deste impacto serão perdidas. Deseja excluir mesmo assim?',
      buttons: [
        {
          name: 'botao-nao',
          component: 'ZdButton',
          label: 'Não',
          outline: true,
          events: {
            click: () => DialogService.hide(),
          },
        },
        {
          name: 'botao-sim',
          component: 'ZdButton',
          label: 'Sim',
          events: {
            click: () => this.excluirImpacto(),
          },
        },
      ],
    });
  }

  public excluirImpacto() {
    Http.post('/ExcluirImpacto', { NRIMPACTOMANUT: this.NR }).then((response: IDictionary) => {
      const mensagemRetorno = response.data.dataset.excluirImp;
      const mensagem = 'Impacto excluído com sucesso!';
      const textoErro = 'Este impacto não pôde ser excluída.';
      this.messages(mensagemRetorno, mensagem, textoErro);
    }).then(() => {
      this.criarCardsImpacto();
      DialogService.hide();
      this.criarCardsPrioridades();
    });
  }

  /* --------------------- FUNÇÕES TAB ESCOPO ---------------------------*/

  public adicionarEscopo() {
    const form = Metadata.getInstance<Form>('form-addEscopo');

    if (form.validate()) {
      Http.post('/EscopoManut', {
        NMESCOPOMANUT: Metadata.getInstance<TextInput>('input-nome-addEscopo').value,
      }).then((response: IDictionary) => {
        const mensagemRetorno = response.data.dataset.escopo;
        const mensagem = 'Escopo adicionado com sucesso!';
        const textoErro = 'Este escopo não pôde ser adicionado.';
        this.messages(mensagemRetorno, mensagem, textoErro);
      }).then(() => {
        this.criarCardsEscopos();
        this.fecharModalAdicionarEscopo();
      });
    } else {
      this.alertaPreencherCampos();
    }
  }

  public criarCardsEscopos() {
    Http.get('/EscopoManut').then((response: IDictionary) => {
      const dadosEscopo = response.data.dataset.escopo[0];
      const escopos = dadosEscopo.map((dados: any) => dados.NMESCOPOMANUT);

      Metadata.getInstance<SelectMultiple>('CampoFiltro_iterable-cards-escopo_NMESCOPOMANUT').updateItems(escopos.filter((nome: string, pos: number) => escopos.indexOf(nome) === pos));

      this.dadosOriginal['iterable-cards-escopo'] = dadosEscopo;
      Metadata.getInstance<IterableComponentRender>('iterable-cards-escopo').datasource.updateData(dadosEscopo);
      this.maisQueUmaPagina({
        component: Metadata.getInstance<Button>('proxima-pagina-botao_iterable-cards-escopo'),
      });
    });
  }

  public alertaExclusaoEscopo({ component }:{ component: Button }) {
    this.NR = Number(component.name.split('_')[1]);
    DialogService.show({
      name: 'buttons-dialog',
      type: 'warning',
      title: 'Excluir escopo',
      text: 'Todas as informações deste escopo serão perdidas. Deseja excluir mesmo assim?',
      buttons: [
        {
          name: 'botao-nao',
          component: 'ZdButton',
          label: 'Não',
          outline: true,
          events: {
            click: () => DialogService.hide(),
          },
        },
        {
          name: 'botao-sim',
          component: 'ZdButton',
          label: 'Sim',
          events: {
            click: () => this.excluirEscopo(),
          },
        },
      ],
    });
  }

  public excluirEscopo() {
    Http.post('/ExcluirEscopo', { NRESCOPOMANUT: this.NR }).then((response: IDictionary) => {
      const mensagemRetorno = response.data.dataset.excluirEscopo;
      const mensagem = 'Escopo excluído com sucesso!';
      const textoErro = 'Este escopo não pôde ser excluída.';
      this.messages(mensagemRetorno, mensagem, textoErro);
    }).then(() => {
      this.criarCardsEscopos();
      DialogService.hide();
    });
  }

  public montarInformacoesEdicaoEscopo() {
    console.log(this.NR);
    Http.post('/Escopos', { NRESCOPOMANUT: this.NR }).then((response: IDictionary) => {
      const dados = response.data.dataset.escopo;

      Metadata.getInstance<TextInput>('input-nome-editarEscopo').value = dados[0].NMESCOPOMANUT;
    });
  }

  public editarEscopo() {
    const form = Metadata.getInstance<Form>('form-editarEscopo');

    if (form.validate()) {
      Http.post('/EditarEscopo', {
        NRESCOPOMANUT: this.NR,
        NMESCOPOMANUT: Metadata.getInstance<TextInput>('input-nome-editarEscopo').value,
      }).then((response: IDictionary) => {
        const mensagemRetorno = response.data.dataset.escopo;
        const mensagem = 'Escopo editado com sucesso!';
        const textoErro = 'Este escopo não pôde ser editado.';
        this.messages(mensagemRetorno, mensagem, textoErro);
      }).then(() => {
        this.criarCardsEscopos();
        this.fecharModalEditarEscopo();
      });
    } else {
      this.alertaPreencherCampos();
    }
  }

  /* ------------------------- FUNÇÕES TAB UNIDADE DE MEDIDAS -----------*/

  public adicionarUnidadeMedida() {
    const form = Metadata.getInstance<Form>('form-addUnidadeMedida');

    if (form.validate()) {
      Http.post('/UnidadeMedida', {
        NMUNIDADEMEDIDA: Metadata.getInstance<TextInput>('input-nome-unidadeMedida').value,
        NMABREVUNIDADEMEDIDA: Metadata.getInstance<TextInput>('input-abreviatura-unidadeMedida').value.toUpperCase(),
      }).then((response: IDictionary) => {
        const mensagemRetorno = response.data.dataset.unMedida;
        const mensagem = 'Unidade de medida adicionada com sucesso!';
        const textoErro = 'Esta unidade de medida não pôde ser adicionado.';
        this.messages(mensagemRetorno, mensagem, textoErro);
      }).then(() => {
        this.criarCardsUnidadeMedida();
        this.fecharModalAdicionarUnidadeMedida();
      });
    } else {
      this.alertaPreencherCampos();
    }
  }

  public criarCardsUnidadeMedida() {
    Http.get('/UnidadeMedida').then((response: IDictionary) => {
      const dadosUnidadeMedida = response.data.dataset.unMedida[0];
      const nomeUniMedida = dadosUnidadeMedida.map((dados: any) => dados.NMUNIDADEMEDIDA);
      const abreviaturaUniMedida = dadosUnidadeMedida.map((dados: any) => dados.NMABREVUNIDADEMEDIDA);

      Metadata.getInstance<SelectMultiple>('CampoFiltro_iterable-cards-unidadeMedida_NMUNIDADEMEDIDA').updateItems(nomeUniMedida.filter((nome: string, pos: number) => nomeUniMedida.indexOf(nome) === pos));
      Metadata.getInstance<SelectMultiple>('CampoFiltro_iterable-cards-unidadeMedida_NMABREVUNIDADEMEDIDA').updateItems(abreviaturaUniMedida.filter((nome: string, pos: number) => abreviaturaUniMedida.indexOf(nome) === pos));

      this.dadosOriginal['iterable-cards-unidadeMedida'] = dadosUnidadeMedida;
      Metadata.getInstance<IterableComponentRender>('iterable-cards-unidadeMedida').datasource.updateData(dadosUnidadeMedida);
      this.maisQueUmaPagina({
        component: Metadata.getInstance<Button>('proxima-pagina-botao_iterable-cards-unidadeMedida'),
      });
    });
  }

  public alertaExclusaoUnidadeMedida({ component }:{ component: Button }) {
    this.NR = Number(component.name.split('_')[1]);
    DialogService.show({
      name: 'buttons-dialog',
      type: 'warning',
      title: 'Excluir unidade de medida',
      text: 'Todas as informações desta unidade de medida serão perdidas. Deseja excluir mesmo assim?',
      buttons: [
        {
          name: 'botao-nao',
          component: 'ZdButton',
          label: 'Não',
          outline: true,
          events: {
            click: () => DialogService.hide(),
          },
        },
        {
          name: 'botao-sim',
          component: 'ZdButton',
          label: 'Sim',
          events: {
            click: () => this.excluirUnidadeMedida(),
          },
        },
      ],
    });
  }

  public excluirUnidadeMedida() {
    Http.post('/ExcluirUnidadeMedida', { NRUNIDADEMEDIDA: this.NR }).then((response: IDictionary) => {
      const mensagemRetorno = response.data.dataset.excluirUni;
      const mensagem = 'Unidade de medida excluída com sucesso!';
      const textoErro = 'Esta unidade de medida não pôde ser excluída.';
      this.messages(mensagemRetorno, mensagem, textoErro);
    }).then(() => {
      this.criarCardsUnidadeMedida();
      DialogService.hide();
    });
  }

  public montarInformacoesEdicaoUnidadeMedida() {
    console.log(this.NR);
    Http.post('/getUnidadeMedidaEspecifica', { NRUNIDADEMEDIDA: this.NR }).then((response: IDictionary) => {
      const dados = response.data.dataset.unidadeMedida;

      Metadata.getInstance<TextInput>('input-nome-editarUnidadeMedida').value = dados[0].NMUNIDADEMEDIDA;
      Metadata.getInstance<TextInput>('input-abreviatura-editarUnidadeMedida').value = dados[0].NMABREVUNIDADEMEDIDA;
    });
  }

  public editarUnidadeMedida() {
    const form = Metadata.getInstance<Form>('form-editarUnidadeMedida');

    if (form.validate()) {
      Http.post('/EditarUnidadeMedida', {
        NRUNIDADEMEDIDA: this.NR,
        NMUNIDADEMEDIDA: Metadata.getInstance<TextInput>('input-nome-editarUnidadeMedida').value,
        NMABREVUNIDADEMEDIDA: Metadata.getInstance<TextInput>('input-abreviatura-editarUnidadeMedida').value.toUpperCase(),
      }).then((response: IDictionary) => {
        const mensagemRetorno = response.data.dataset.unidadeMedida;
        const mensagem = 'Unidade de medida editada com sucesso!';
        const textoErro = 'Esta unidade de medida não pôde ser editada.';
        this.messages(mensagemRetorno, mensagem, textoErro);
      }).then(() => {
        this.criarCardsUnidadeMedida();
        this.fecharModalEditarUnidadeMedida();
      });
    } else {
      this.alertaPreencherCampos();
    }
  }
}
